<?php

namespace OroCRM\Bundle\TaskBundle\Migrations\Schema;

use Doctrine\DBAL\Schema\Schema;

use Oro\Bundle\MigrationBundle\Migration\Installation;
use Oro\Bundle\MigrationBundle\Migration\QueryBag;
use OroCRM\Bundle\TaskBundle\Migrations\Schema\v1_0\OroCRMTaskBundle;
use OroCRM\Bundle\TaskBundle\Migrations\Schema\v1_1\OroCRMTaskBundle as OroCRMTaskBundle11;

class OroCRMTaskBundleInstaller implements Installation
{
    public function getMigrationVersion()
    {
        return 'v1_1';
    }

    /**
     * Modifies the given schema to apply necessary changes of a database
     * The given query bag can be used to apply additional SQL queries before and after schema changes
     *
     * @param Schema $schema
     * @param QueryBag $queries
     * @return void
     */
    public function up(Schema $schema, QueryBag $queries)
    {
        $migration = new OroCRMTaskBundle();
        $migration->up($schema, $queries);

        OroCRMTaskBundle11::addOrganization($schema);
    }
}
